<?php

/**
 * Front-End of Jflip_XH.
 *
 * Copyright (c) 2012 Christoph M. Becker (see license.txt)
 */


if (!defined('CMSIMPLE_XH_VERSION')) {
    header('HTTP/1.0 403 Forbidden');
    exit;
}


define('JFLIP_VERSION', '1dev1');


/**
 * Returns the list of all images in the folder $fn.
 *
 * @param string $fn
 * @return array
 */
function jflip_images($fn) {
    $imgs = glob($fn.'/*');
    $imgs = array_filter($imgs, create_function('$f', 'return is_file($f) && getimagesize($f);'));
    natcasesort($imgs);
    return $imgs;
}

/**
 * Writes the necessary JS to the <head>.
 *
 * @global $hjs
 * @return void
 */
function jflip_js() {
    global $pth, $hjs, $plugin_cf, $plugin_tx;

    $pcf = $plugin_cf['jflip'];
    $ptx = $plugin_tx['jflip'];
    $hjs .= tag('link rel="stylesheet" href="" type="text/css"')."\n"
	    .'<!--[if IE]><script type="text/javascript" src="'.$pth['folder']['plugins']
		.'jflip/lib/excanvasX.js"></script><![endif]-->'."\n";
    include_once $pth['folder']['plugins'].'jquery/jquery.inc.php';
    include_jquery();
    include_jqueryplugin('jflip', $pth['folder']['plugins'].'jflip/lib/jquery.jflip-0.4.min.js');

    $hjs .= <<<SCRIPT
<script type="text/javascript">
/* <![CDATA[ */
jQuery(function() {
    jQuery('#jflip').jFlip($pcf[width], $pcf[height], {background: '$pcf[background]'})
	    .bind('flip.jflip', function(event, index, total) {
		$('#jflip_label').html('$ptx[label_image] ' + (index+1) + '$ptx[label_of]' + total);
	    })
})
/* ]]> */
</script>

SCRIPT;
}


/**
 * Displays a book with all images in folder $fn.
 *
 * @access public
 * @param string $fn  Name of a folder relative to the root.
 * @return string  The (X)HTML.
 */
function jflip($fn) {
    global $plugin_tx;

    $ptx = $plugin_tx['jflip'];
    jflip_js();
    $o = '<ul id="jflip">'."\n";
    foreach (($imgs = jflip_images($fn)) as $img) {
	$o .= '<li>'.tag('img src="'.$img.'" alt="'.basename($img).'"').'</li>'."\n";
    }
    $o .= '</ul>'."\n"
	    .'<div id="jflip_label">'.$ptx['label_image'].' 1'.$ptx['label_of'].count($imgs).'</div>'."\n";
    return $o;
}

?>
